/*
 * Ch6b_AttachSession.sql
 * Copyright 2001 Matthew J. Holmes
 */

IF EXISTS (SELECT * FROM sysObjects WHERE ID = Object_Id('Ch6b_AttachSession'))
	DROP PROC Ch6b_AttachSession
GO

CREATE PROC Ch6b_AttachSession
	@Device		VARCHAR50
AS
	DECLARE @RID	int
	DECLARE @SID	int

	/* Remove old sessions */
	DELETE tbSession WHERE DATEDIFF(HOUR, LastAccess, GETDATE()) >= 4

	/* Find the radio */
	SELECT @RID = R.RID FROM tbRadio R WHERE R.Device = @Device
	IF @RID IS NULL RETURN 1

	/* Session present or expired? */
	SELECT @SID = S.SID FROM tbSession S WHERE S.RID = @RID
	IF @SID IS NULL	RETURN 2
			
	UPDATE tbSession SET LastAccess = GETDATE() WHERE SID = @SID
	RETURN 0
GO